-- Super-Duper Grenade
-- SENT by Teta_Bonita

AddCSLuaFile("cl_init.lua")
AddCSLuaFile("shared.lua")
include("shared.lua")


local GrenadeModel = "models/items/AR2_Grenade.mdl"
util.PrecacheModel(GrenadeModel)

function ENT:Initialize()

	self.Entity:SetModel(GrenadeModel)

	self.Entity:PhysicsInit(SOLID_VPHYSICS)
	self.Entity:SetCollisionGroup(COLLISION_GROUP_PROJECTILE)

	self.PhysObj = self.Entity:GetPhysicsObject()
	if (self.PhysObj:IsValid()) then
		self.PhysObj:Wake()
	end
	
	self.Damage = self.Entity:GetVar("Damage",100)
	self.Owner = self.Entity:GetOwner()
	self.Armed = false
	
end

function ENT:Explode(normal)

	local Position = self.Entity:GetPos()


	util.BlastDamage(self.Entity, self.Entity, Position, 2.5*self.Damage, self.Damage)
	

	local fx = EffectData()
	fx:SetOrigin(Position)
	util.Effect("Explosion",fx)

	self.Entity:Remove()
	
	
end


function ENT:PhysicsCollide(data, physobj)

	if data.Speed > 50 and data.DeltaTime > 0.3 then
	
		if not self.Armed then
		
			--Bounce like a crazy bitch
			local LastSpeed = data.OurOldVelocity:Length()
			local NewVelocity = physobj:GetVelocity()
			
			local TargetVelocity = NewVelocity + (LastSpeed*0.2)*NewVelocity:GetNormalized()
			physobj:SetVelocity(TargetVelocity)
		
			timer.Simple(0.1, self.Explode, self, data.HitNormal)
			self.Armed = true
			
		end

	end

end


function ENT:OnTakeDamage(dmginfo)

	self.Entity:TakePhysicsDamage(dmginfo)
	
end


function ENT:Think()


end

